#include <LittleRobotFriends.h>

int fate = 0; //stores responce

bool headHeld = false;    //stores state of the head sensor touched / not touched
bool firstRun = true;     //stores whether or not this is the first time starting up




LRFExpression thinkingExpression =        //expressions for each reaction
{
  .pattern = { LRFColor_White, LRFColor_Blue, LRFTransform_Random, LRFDuration_DoubleLong },
  .sounds = {
    { LRFNote_C, LRFOctave_3, LRFIntonation_Rising, LRFDuration_DoubleLong, LRFDuration_Medium },
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK
  }
};

LRFExpression yesExpression =           //yes expression
{
  .pattern = { LRFColor_White, LRFColor_Blue, LRFTransform_None, LRFDuration_DoubleLong },
  .sounds = {
    { LRFNote_C, LRFOctave_3, LRFIntonation_Rising, LRFDuration_DoubleLong, LRFDuration_Medium },
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK
  }
};


LRFExpression noExpression =          //no expression
{
  .pattern = { LRFColor_White, LRFColor_Red, LRFTransform_None, LRFDuration_DoubleLong },
  .sounds = {

    { LRFNote_C, LRFOctave_3, LRFIntonation_Falling, LRFDuration_DoubleLong, LRFDuration_Medium },
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK
  }
};


LRFExpression maybeExpression =         //maybe expression
{
  .pattern = { LRFColor_White, LRFColor_Yellow, LRFTransform_None, LRFDuration_DoubleLong },
  .sounds = {
    { LRFNote_C, LRFOctave_3, LRFIntonation_Peaking, LRFDuration_DoubleLong, LRFDuration_Medium },
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK,
    LRF_SOUND_BLANK
  }
};

void setup() {
  lrf.setup();
  lrf.disableEventExpressions();      //disable default expressions
  lrf.setBoredomTimer(0);             //disable boredom timer
}

void loop() {
  lrf.loop();
  
  if (firstRun == true) {           //check to see if this is the first time running
    randomSeed(lrf.sight.read());   //set up the random number generator
    fate = random(2);               //assign the random "fate" value
    // LRF_DEBUG_SNL(currentSongIdx);
    firstRun = false;               //change state of "firstRun" to false
  }

  checkHeadSensor();              //check the state of the headsensor (without using an event handler)

  if (headHeld == true) {
    lrf.eyes.set(100, 100, 100);    //make eyes white while head sensor is being held
  }



}

void checkHeadSensor() {

  if (lrf.touch.readHair() == 1) {          //if hair sensor is being touched

    if (headHeld == false) {

      headHeld = true;
    }

 

  }

  else if (lrf.touch.readHair() == 0) {   //if hair sensor is not being touched

    if (headHeld == true) {             //if the hair sensor was being held previously and now released
      //released
      fate = random(3);               //determin "fate"
      lrf.eyes.set(0, 0, 0);          //clear eyes
      switch (fate) {                 //determine which expression to make 
        case 0 :
          lrf.blinkAndSay(&noExpression);
          break;

        case 1 :
          lrf.blinkAndSay(&yesExpression);
          break;

        case 2 :
          lrf.blinkAndSay(&maybeExpression);
          break;
      }
      headHeld = false;           //change the value untill next time the hair sensor is held
    }

  }

}




